tweak PATH for debootstrap
[build.git] / lbuild-initvm.sh
index ee669c1..0395fe1 100755 (executable)
@@ -11,17 +11,33 @@ BUILD_DIR=$(pwd)
 PATH=$(dirname $0):$PATH export PATH
 . build.common
 
-DEFAULT_FCDISTRO=f16
-DEFAULT_PLDISTRO=planetlab
+DEFAULT_FCDISTRO=f20
+DEFAULT_PLDISTRO=lxc
 DEFAULT_PERSONALITY=linux64
 
 COMMAND_LBUILD="lbuild-initvm.sh"
 COMMAND_LTEST="ltest-initvm.sh"
 
-libvirt_version="1.0.4"
+##########
+# when creating build boxes we use private NAT'ed addresses for the VMs
+# as per virbr0 that is taken care of by libvirt at startup
+PRIVATE_BRIDGE="virbr0"
+PRIVATE_PREFIX="192.168.122."
+PRIVATE_GATEWAY="192.168.122.1"
+# beware that changing this would break the logic of random_private_byte...
+PRIVATE_MASKLEN=24
 
+# we just try randomly in that range until a free IP address shows up
+PRIVATE_ATTEMPTS=20
+
+# constant
+PUBLIC_BRIDGE=br0
+
+# the network interface name as seen from the container
+VIF_GUEST=eth0
+
+##############################
 ## stolen from tests/system/template-qemu/qemu-bridge-init
-#################### compute INTERFACE_LAN
 # use /proc/net/dev instead of a hard-wired list
 function gather_interfaces () {
     python <<EOF
@@ -35,7 +51,7 @@ for line in file("/proc/net/dev"):
     print ifname
 EOF
 }
-    
+
 function discover_interface () {
     for ifname in $(gather_interfaces); do
        ip link show $ifname | grep -qi 'state UP' && { echo $ifname; return; }
@@ -43,26 +59,80 @@ function discover_interface () {
     # still not found ? that's bad
     echo unknown
 }
-DEFAULT_IFNAME=$(discover_interface)
+########## check for a free IP
+function ip_is_busy () {
+    target=$1; shift
+    ping -c 1 -W 1 $target >& /dev/null
+}
 
-function bridge_init () {
+function random_private_byte () {
+    for attempt in $(seq $PRIVATE_ATTEMPTS); do
+       byte=$(($RANDOM % 256))
+       if [ "$byte" == 0 -o "$byte" == 1 ] ; then continue; fi
+       ip=${PRIVATE_PREFIX}${byte}
+       ip_is_busy $ip || { echo $byte; return; }
+    done
+    echo "Cannot seem to find a free IP address in range ${PRIVATE_PREFIX}.xx/24 after $PRIVATE_ATTEMPTS attempts - exiting"
+    exit 1
+}
+
+########## networking -- ctd
+function gethostbyname () {
+    hostname=$1
+    python -c "import socket; print socket.gethostbyname('"$hostname"')" 2> /dev/null
+}
 
+# e.g. 21 -> 255.255.248.0
+function masklen_to_netmask () {
+    masklen=$1; shift
+    python <<EOF
+import sys
+masklen=$masklen
+if not (masklen>=1 and masklen<=32): 
+  print "Wrong masklen",masklen
+  exit(1)
+result=[]
+for i in range(4):
+    if masklen>=8:
+       result.append(8)
+       masklen-=8
+    else:
+       result.append(masklen)
+       masklen=0
+print ".".join([ str(256-2**(8-i)) for i in result ])
+  
+EOF
+}
+
+#################### bridge initialization
+function create_bridge_if_needed() {
+   
     # turn on verbosity
     set -x
 
-    # constant
-    INTERFACE_BRIDGE=br0
+    # already created ? - we're done
+    ip addr show $PUBLIC_BRIDGE >& /dev/null && {
+       echo "Bridge already set up - skipping create_bridge_if_needed"
+       return 0
+    }
 
-    # Default Value for INTERFACE_LAN
-    INTERFACE_LAN=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
+    # find out the physical interface to bridge onto
+    if_lan=$(discover_interface)
 
+    ip addr show $if_lan &>/dev/null || {
+        echo "Cannot use interface $if_lan - exiting"
+        exit 1
+    }
+
+    #################### bride initialization
+    check_yum_installed bridge-utils
 
-    echo "========== $COMMAND: entering start - beg"
+    echo "========== $COMMAND: entering create_bridge - beg"
     hostname
     uname -a
-    ifconfig
-    netstat -rn
-    echo "========== $COMMAND: entering start - end"
+    ip addr show
+    ip route
+    echo "========== $COMMAND: entering create_bridge - end"
 
     # disable netfilter calls for bridge interface (they cause panick on 2.6.35 anyway)
     #
@@ -72,86 +142,89 @@ function bridge_init () {
     sysctl net.bridge.bridge-nf-call-ip6tables=0
     sysctl net.bridge.bridge-nf-call-arptables=0
 
-    # take extra arg for ifname, if provided
-    [ -n "$1" ] && { INTERFACE_LAN=$1; shift ; }
-
-    #if we have already configured the same host_box no need to do it again
-    /sbin/ifconfig $INTERFACE_BRIDGE &> /dev/null && {
-        echo "Bridge interface $INTERFACE_BRIDGE already set up - $COMMAND start exiting"
-        return 0
-    }
-    /sbin/ifconfig $INTERFACE_LAN &>/dev/null || {
-        echo "Cannot use interface $INTERFACE_LAN - exiting"
-        exit 1
-    }
-
     
     #Getting host IP/masklen
-    address=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $2;}')
-    [ -z "$address" ] && { echo "ERROR: Could not determine IP address for $INTERFACE_LAN" ; exit 1 ; }
+    address=$(ip addr show $if_lan | grep -v inet6 | grep inet | head --lines=1 | awk '{print $2;}')
+    [ -z "$address" ] && { echo "ERROR: Could not determine IP address for $if_lan" ; exit 1 ; }
 
-    broadcast=$(/sbin/ip addr show $INTERFACE_LAN | grep -v inet6 | grep inet | head --lines=1 | awk '{print $4;}')
-    [ -z "$broadcast" ] && echo "WARNING: Could not determine broadcast address for $INTERFACE_LAN"
+    broadcast=$(ip addr show $if_lan | grep -v inet6 | grep inet | head --lines=1 | awk '{print $4;}')
+    [ -z "$broadcast" ] && echo "WARNING: Could not determine broadcast address for $if_lan"
 
-    gateway=$(netstat -rn | grep '^0.0.0.0' | awk '{print $2;}')
+    gateway=$(ip route show | grep default | awk '{print $3;}')
     [ -z "$gateway" ] && echo "WARNING: Could not determine gateway IP"
 
+
     # creating the bridge
-    echo "Creating bridge INTERFACE_BRIDGE=$INTERFACE_BRIDGE"
-    brctl addbr $INTERFACE_BRIDGE
-    #brctl stp $INTERFACE_BRIDGE yes
-    brctl addif $INTERFACE_BRIDGE $INTERFACE_LAN
-    echo "Activating promiscuous mode INTERFACE_LAN=$INTERFACE_LAN"
-    /sbin/ifconfig $INTERFACE_LAN 0.0.0.0 promisc up
+    echo "Creating bridge PUBLIC_BRIDGE=$PUBLIC_BRIDGE"
+    brctl addbr $PUBLIC_BRIDGE
+    brctl addif $PUBLIC_BRIDGE $if_lan
+    echo "Activating promiscuous mode if_lan=$if_lan"
+    ip link set $if_lan up promisc on
     sleep 2
-    echo "Setting bridge address=$address broadcast=$broadcast"
-    # static
-    #/sbin/ifconfig $INTERFACE_BRIDGE $address broadcast $broadcast up
-    dhclient $INTERFACE_BRIDGE
+    # rely on dhcp to re assign IP.. 
+    echo "Starting dhclient on $PUBLIC_BRIDGE"
+    dhclient $PUBLIC_BRIDGE
     sleep 1
 
     #Reconfigure the routing table
     echo "Configuring gateway=$gateway"
-    route add default gw $gateway
-
-    echo "========== $COMMAND: exiting start - beg"
-    ifconfig
-    netstat -rn
-    echo "========== $COMMAND: exiting start - end"
-
-
-return 0
+    ip route add default via $gateway dev $PUBLIC_BRIDGE
+    ip route del default via $gateway dev $if_lan
+    # at this point we have an extra route like e.g.
+    ## ip route show
+    #default via 138.96.112.250 dev br0
+    #138.96.112.0/21 dev em1  proto kernel  scope link  src 138.96.112.57
+    #138.96.112.0/21 dev br0  proto kernel  scope link  src 138.96.112.57
+    #192.168.122.0/24 dev virbr0  proto kernel  scope link  src 192.168.122.1
+    route_dest=$(ip route show | grep -v default | grep "dev $PUBLIC_BRIDGE" | awk '{print $1;}')
+    ip route del $route_dest dev $if_lan
+
+    echo "========== $COMMAND: exiting create_bridge - beg"
+    ip addr show
+    ip route show
+    echo "========== $COMMAND: exiting create_bridge - end"
+
+    # for safety
+    sleep 3
+    return 0
 
 }
 
-
-function failure () {
-    echo "$COMMAND : Bailing out"
-    exit 1
+##############################
+# return yum or debootstrap
+function package_method () {
+    fcdistro=$1; shift
+    case $fcdistro in
+       f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
+       squeeze|wheezy|oneiric|precise|quantal|raring|saucy) echo debootstrap ;;
+       *) echo Unknown distro $fcdistro ;;
+    esac 
 }
 
-function cidr_notation () {
-
-netmask=$1; shift
-cidr=0
-for i in $(seq 1 4) ; do
-    part=$(echo $netmask | cut -d. -f $i)
-    case $part in
-        "255") cidr=$((cidr + 8));;
-        "254") cidr=$((cidr + 7));;
-        "252") cidr=$((cidr + 6));;
-        "248") cidr=$((cidr + 5));;
-        "240") cidr=$((cidr + 4));;
-        "224") cidr=$((cidr + 3));;
-        "192") cidr=$((cidr + 2));;
-        "128") cidr=$((cidr + 1));;
-        "0") cidr=$((cidr + 0));;
-     esac
-done
-echo $cidr
+# return arch from debian distro and personality
+function canonical_arch () {
+    personality=$1; shift
+    fcdistro=$1; shift
+    case $(package_method $fcdistro) in
+       yum)
+           case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
+       debootstrap)
+           case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
+       *)
+           echo Unknown-arch-3 ;;
+    esac
+}
 
+# the new test framework creates /timestamp in /vservers/<name> *before* populating it
+function almost_empty () { 
+    dir="$1"; shift ; 
+    # non existing is fine
+    [ ! -d $dir ] && return 0; 
+    # need to have at most one file
+    count=$(cd $dir; ls | wc -l); [ $count -le 1 ]; 
 }
 
+##############################
 function check_yum_installed () {
     package=$1; shift
     rpm -q $package >& /dev/null || yum -y install $package
@@ -162,128 +235,40 @@ function check_yumgroup_installed () {
     yum grouplist "$group" | grep -q Installed || { yum -y groupinstall "$group" ; }
 }
 
-function prepare_host() {
-   
-### Thierry - jan 14 - turning off this check as our boxes now meet this req.
-### and I'm trying out f20's stock libvirt instead    
-#    ## check if libvirt_version is installed
-#    virsh -v | grep -e $libvirt_version || { echo "$libvirt_version needs to be installed!!!" ; exit 1 ; }
-
-    #################### bride initialization
-    check_yum_installed bridge-utils
-    #Bridge init
-    isInstalled=$(netstat -rn | grep '^0.0.0.0' | awk '{print $8;}')
-    if [ "$isInstalled" != "br0" ] ; then
-       bridge_init
-        sleep 5
-    fi
-
-    return 0
-}
-
-
-
-function configure_fedora() {
-
-    # disable selinux in fedora
-    mkdir -p $rootfs_path/selinux
-    echo 0 > $rootfs_path/selinux/enforce
-
-   # configure the network 
-
-    cat <<EOF > ${rootfs_path}/etc/sysconfig/network-scripts/ifcfg-$IFNAME
-DEVICE=$IFNAME
-BOOTPROTO=static
-ONBOOT=yes
-HOSTNAME=$HOSTNAME
-IPADDR=$IP
-NETMASK=$NETMASK
-GATEWAY=$GATEWAY
-NM_CONTROLLED=no
-TYPE=Ethernet
-MTU=1500
-EOF
-
-    # set the hostname
-    case "$fcdistro" in 
-       f18|f2?)
-           cat <<EOF > ${rootfs_path}/etc/hostname
-$HOSTNAME
-EOF
-           echo ;;
-       *)
-            cat <<EOF > ${rootfs_path}/etc/sysconfig/network
-NETWORKING=yes
-HOSTNAME=$HOSTNAME
-EOF
-            # set minimal hosts
-           cat <<EOF > $rootfs_path/etc/hosts
-127.0.0.1 localhost $HOSTNAME
-EOF
-           echo ;;
-    esac
-
-    dev_path="${rootfs_path}/dev"
-    rm -rf $dev_path
-    mkdir -p $dev_path
-    mknod -m 666 ${dev_path}/null c 1 3
-    mknod -m 666 ${dev_path}/zero c 1 5
-    mknod -m 666 ${dev_path}/random c 1 8
-    mknod -m 666 ${dev_path}/urandom c 1 9
-    mkdir -m 755 ${dev_path}/pts
-    mkdir -m 1777 ${dev_path}/shm
-    mknod -m 666 ${dev_path}/tty c 5 0
-    mknod -m 666 ${dev_path}/tty0 c 4 0
-    mknod -m 666 ${dev_path}/tty1 c 4 1
-    mknod -m 666 ${dev_path}/tty2 c 4 2
-    mknod -m 666 ${dev_path}/tty3 c 4 3
-    mknod -m 666 ${dev_path}/tty4 c 4 4
-    mknod -m 600 ${dev_path}/console c 5 1
-    mknod -m 666 ${dev_path}/full c 1 7
-    mknod -m 600 ${dev_path}/initctl p
-    mknod -m 666 ${dev_path}/ptmx c 5 2
-
-    #echo "setting root passwd to $root_password"
-    #echo "root:$root_password" | chroot $rootfs_path chpasswd
+##############################
+function fedora_install() {
+    set -x
+    set -e
 
-    return 0
-}
+    mkdir -p /var/lock/subsys/
+    (
+        flock -n -x 200 || { echo "Cache repository is busy." ; return 1 ; }
 
+        if [ ! -e "$cache/rootfs" ]; then
+            echo "Getting cache download in $cache/rootfs ... "
+            fedora_download || { echo "Failed to download 'fedora base'"; return 1; }
+        else
+            echo "Updating cache $cache/rootfs ..."
+           if ! yum --installroot $cache/rootfs -y --nogpgcheck update ; then
+                echo "Failed to update 'fedora base', continuing with last known good cache"
+            else
+                echo "Update finished"
+            fi
+        fi
 
-function configure_fedora_init() {
+        echo "Copy $cache/rootfs to $rootfs_path ... "
+       mkdir -p $rootfs_path
+       rsync -a $cache/rootfs/ $rootfs_path/
+       
+        return 0
 
-    sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.sysinit
-    sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.d/rc.sysinit
-    # don't mount devpts, for pete's sake
-    sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.sysinit
-    sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.d/rc.sysinit
-    chroot ${rootfs_path} /sbin/chkconfig udev-post off
-    chroot ${rootfs_path} /sbin/chkconfig network on
-}
+        ) 200>/var/lock/subsys/lxc
 
-# this code of course is for guests that do run on systemd
-function configure_fedora_systemd() {
-    # so ignore if we can't find /etc/systemd at all 
-    [ -d ${rootfs_path}/etc/systemd ] || return 0
-    # otherwise let's proceed
-    ln -sf /lib/systemd/system/multi-user.target ${rootfs_path}/etc/systemd/system/default.target
-    touch ${rootfs_path}/etc/fstab
-    ln -sf /dev/null ${rootfs_path}/etc/systemd/system/udev.service
-# Thierry - Feb 2013
-# this was intended for f16 initially, in order to enable getty that otherwise would not start
-# having a getty running is helpful only if ssh won't start though, and we see a correlation between
-# VM's that refuse to lxc-stop and VM's that run crazy getty's
-# so, turning getty off for now instead
-#   #dependency on a device unit fails it specially that we disabled udev
-#    sed -i 's/After=dev-%i.device/After=/' ${rootfs_path}/lib/systemd/system/getty\@.service
-    ln -sf /dev/null ${rootfs_path}/etc/systemd/system/"getty@.service"
-    rm -f ${rootfs_path}/etc/systemd/system/getty.target.wants/*service || :
-# can't seem to handle this one with systemctl
-    chroot ${rootfs_path} /sbin/chkconfig network on
+    return $?
 }
 
-function download_fedora() {
-set -x
+function fedora_download() {
+    set -x
     # check the mini fedora was not already downloaded
     INSTALL_ROOT=$cache/partial
     echo $INSTALL_ROOT
@@ -291,11 +276,7 @@ set -x
     # download a mini fedora into a cache
     echo "Downloading fedora minimal ..."
 
-    mkdir -p $INSTALL_ROOT
-    if [ $? -ne 0 ]; then
-        echo "Failed to create '$INSTALL_ROOT' directory"
-        return 1
-    fi
+    mkdir -p $INSTALL_ROOT || { echo "Failed to create '$INSTALL_ROOT' directory" ; return 1; }
 
     mkdir -p $INSTALL_ROOT/etc/yum.repos.d   
     mkdir -p $INSTALL_ROOT/dev
@@ -307,8 +288,7 @@ set -x
     cp /etc/yum.repos.d/fedora* $INSTALL_ROOT/etc/yum.repos.d/
 
     # append fedora repo files with desired $release and $basearch
-    for f in $INSTALL_ROOT/etc/yum.repos.d/*
-    do
+    for f in $INSTALL_ROOT/etc/yum.repos.d/* ; do
       sed -i "s/\$basearch/$arch/g; s/\$releasever/$release/g;" $f
     done 
 
@@ -346,12 +326,7 @@ set -x
     YUM="yum --installroot=$INSTALL_ROOT --nogpgcheck -y"
     PKG_LIST="yum initscripts passwd rsyslog vim-minimal dhclient chkconfig rootfiles policycoreutils openssh-server openssh-clients"
     echo "$YUM install $PKG_LIST"
-    $YUM install $PKG_LIST
-
-    if [ $? -ne 0 ]; then
-        echo "Failed to download the rootfs, aborting."
-        return 1
-    fi
+    $YUM install $PKG_LIST || { echo "Failed to download rootfs, aborting." ; return 1; }
 
     mv "$INSTALL_ROOT" "$cache/rootfs"
     echo "Download complete."
@@ -359,125 +334,106 @@ set -x
     return 0
 }
 
+##############################
+function fedora_configure() {
 
-function copy_fedora() {
-set -x
-    # make a local copy of the minifedora
-    echo -n "Copying rootfs to $rootfs_path ..."
-    mkdir -p $rootfs_path
-    rsync -a $cache/rootfs/ $rootfs_path/
-    return 0
-}
-
-
-function update_fedora() {
-set -x
-    YUM="yum --installroot $cache/rootfs -y --nogpgcheck"
-    $YUM update
-}
-
-
-function install_fedora() {
     set -x
+    set -e
 
-    mkdir -p /var/lock/subsys/
-    (
-        flock -n -x 200
-        if [ $? -ne 0 ]; then
-            echo "Cache repository is busy."
-            return 1
-        fi
-
-        echo "Checking cache download in $cache/rootfs ... "
-        if [ ! -e "$cache/rootfs" ]; then
-            download_fedora
-            if [ $? -ne 0 ]; then
-                echo "Failed to download 'fedora base'"
-                return 1
-            fi
-        else
-            echo "Cache found. Updating..."
-            update_fedora
-            if [ $? -ne 0 ]; then
-                echo "Failed to update 'fedora base', continuing with last known good cache"
-            else
-                echo "Update finished"
-            fi
-        fi
-
-        echo "Copy $cache/rootfs to $rootfs_path ... "
-        copy_fedora
-        if [ $? -ne 0 ]; then
-            echo "Failed to copy rootfs"
-            return 1
-        fi
-
-        return 0
-
-        ) 200>/var/lock/subsys/lxc
-
-    return $?
-}
-
+    # disable selinux in fedora
+    mkdir -p $rootfs_path/selinux
+    echo 0 > $rootfs_path/selinux/enforce
 
-function copy_configuration() {
-
-    mkdir -p $config_path
-    cat <<EOF >> $config_path/config
-lxc.utsname = $lxc
-lxc.arch = $arch2
-lxc.tty = 4
-lxc.pts = 1024
-lxc.rootfs = $rootfs_path
-lxc.mount  = $config_path/fstab
-#networking
-lxc.network.type = $lxc_network_type
-lxc.network.flags = up
-lxc.network.link = $lxc_network_link
-lxc.network.name = $IFNAME
-lxc.network.mtu = 1500
-lxc.network.ipv4 = $IP/$CIDR
-lxc.network.veth.pair = $veth_pair
-#cgroups
-#lxc.cgroup.devices.deny = a
-# /dev/null and zero
-lxc.cgroup.devices.allow = c 1:3 rwm
-lxc.cgroup.devices.allow = c 1:5 rwm
-# consoles
-lxc.cgroup.devices.allow = c 5:1 rwm
-lxc.cgroup.devices.allow = c 5:0 rwm
-lxc.cgroup.devices.allow = c 4:0 rwm
-lxc.cgroup.devices.allow = c 4:1 rwm
-# /dev/{,u}random
-lxc.cgroup.devices.allow = c 1:9 rwm
-lxc.cgroup.devices.allow = c 1:8 rwm
-lxc.cgroup.devices.allow = c 136:* rwm
-lxc.cgroup.devices.allow = c 5:2 rwm
-# rtc
-lxc.cgroup.devices.allow = c 254:0 rwm
-lxc.cgroup.devices.allow = b 255:0 rwm
+    # set the hostname
+    case "$fcdistro" in 
+       f18|f2?)
+           cat <<EOF > ${rootfs_path}/etc/hostname
+$GUEST_HOSTNAME
+EOF
+           echo ;;
+       *)
+            cat <<EOF > ${rootfs_path}/etc/sysconfig/network
+NETWORKING=yes
+HOSTNAME=$GUEST_HOSTNAME
 EOF
+            # set minimal hosts
+           cat <<EOF > $rootfs_path/etc/hosts
+127.0.0.1 localhost $GUEST_HOSTNAME
+EOF
+           echo ;;
+    esac
 
+    dev_path="${rootfs_path}/dev"
+    rm -rf $dev_path
+    mkdir -p $dev_path
+    mknod -m 666 ${dev_path}/null c 1 3
+    mknod -m 666 ${dev_path}/zero c 1 5
+    mknod -m 666 ${dev_path}/random c 1 8
+    mknod -m 666 ${dev_path}/urandom c 1 9
+    mkdir -m 755 ${dev_path}/pts
+    mkdir -m 1777 ${dev_path}/shm
+    mknod -m 666 ${dev_path}/tty c 5 0
+    mknod -m 666 ${dev_path}/tty0 c 4 0
+    mknod -m 666 ${dev_path}/tty1 c 4 1
+    mknod -m 666 ${dev_path}/tty2 c 4 2
+    mknod -m 666 ${dev_path}/tty3 c 4 3
+    mknod -m 666 ${dev_path}/tty4 c 4 4
+    mknod -m 600 ${dev_path}/console c 5 1
+    mknod -m 666 ${dev_path}/full c 1 7
+    mknod -m 600 ${dev_path}/initctl p
+    mknod -m 666 ${dev_path}/ptmx c 5 2
 
+    #echo "setting root passwd to $root_password"
+    #echo "root:$root_password" | chroot $rootfs_path chpasswd
 
-    cat <<EOF > $config_path/fstab
-proc            $rootfs_path/proc         proc    nodev,noexec,nosuid 0 0
-devpts          $rootfs_path/dev/pts      devpts defaults 0 0
-sysfs           $rootfs_path/sys          sysfs defaults  0 0
-EOF
-    if [ $? -ne 0 ]; then
-        echo "Failed to add configuration"
-        return 1
+    if [ "$(echo $fcdistro | cut -d"f" -f2)" -le "14" ]; then
+       fedora_configure_init
+    else
+       fedora_configure_systemd
     fi
 
+    fedora_configure_yum $lxc $fcdistro $pldistro
+
     return 0
 }
 
+function fedora_configure_init() {
+    set -e
+    set -x
+    sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.sysinit
+    sed -i 's|.sbin.start_udev||' ${rootfs_path}/etc/rc.d/rc.sysinit
+    # don't mount devpts, for pete's sake
+    sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.sysinit
+    sed -i 's/^.*dev.pts.*$/#\0/' ${rootfs_path}/etc/rc.d/rc.sysinit
+    chroot ${rootfs_path} /sbin/chkconfig udev-post off
+    chroot ${rootfs_path} /sbin/chkconfig network on
+}
 
+# this code of course is for guests that do run on systemd
+function fedora_configure_systemd() {
+    set -e
+    set -x
+    # so ignore if we can't find /etc/systemd at all 
+    [ -d ${rootfs_path}/etc/systemd ] || return 0
+    # otherwise let's proceed
+    ln -sf /lib/systemd/system/multi-user.target ${rootfs_path}/etc/systemd/system/default.target
+    touch ${rootfs_path}/etc/fstab
+    ln -sf /dev/null ${rootfs_path}/etc/systemd/system/udev.service
+# Thierry - Feb 2013
+# this was intended for f16 initially, in order to enable getty that otherwise would not start
+# having a getty running is helpful only if ssh won't start though, and we see a correlation between
+# VM's that refuse to lxc-stop and VM's that run crazy getty's
+# so, turning getty off for now instead
+#   #dependency on a device unit fails it specially that we disabled udev
+#    sed -i 's/After=dev-%i.device/After=/' ${rootfs_path}/lib/systemd/system/getty\@.service
+    ln -sf /dev/null ${rootfs_path}/etc/systemd/system/"getty@.service"
+    rm -f ${rootfs_path}/etc/systemd/system/getty.target.wants/*service || :
+# can't seem to handle this one with systemctl
+    chroot ${rootfs_path} /sbin/chkconfig network on
+}
 
-
-# overwrite lxc's internal yum config
-function configure_yum_in_lxc () {
+# overwrite container yum config
+function fedora_configure_yum () {
     set -x 
     set -e 
     trap failure ERR INT
@@ -486,6 +442,9 @@ function configure_yum_in_lxc () {
     fcdistro=$1; shift
     pldistro=$1; shift
 
+    # rpm --rebuilddb
+    chroot $rootfs_path /bin/rpm --rebuilddb
+
     echo "Initializing yum.repos.d in $lxc"
     rm -f $rootfs_path/etc/yum.repos.d/*
 
@@ -509,7 +468,7 @@ EOF
     
     # for using vtest-init-lxc.sh as a general-purpose lxc creation wrapper
     # just mention 'none' as the repo url
-    if [ -n "$TEST_MODE" -a "$REPO_URL" != "none" ] ; then
+    if [ -n "$REPO_URL" ] ; then
        if [ ! -d $rootfs_path/etc/yum.repos.d ] ; then
            echo "WARNING : cannot create myplc repo"
        else
@@ -530,39 +489,34 @@ EOF
     fi
 }    
 
-# return yum or debootstrap
-function package_method () {
+##############################
+# need to specify the right mirror for debian variants like ubuntu and the like
+function debian_mirror () {
     fcdistro=$1; shift
     case $fcdistro in
-       f[0-9]*|centos[0-9]*|sl[0-9]*) echo yum ;;
-       lenny|etch) echo debootstrap ;;
-       *) echo Unknown distro $fcdistro ;;
-    esac 
-}
-
-# return arch from debian distro and personality
-function canonical_arch () {
-    personality=$1; shift
-    fcdistro=$1; shift
-    case $(package_method $fcdistro) in
-       yum)
-           case $personality in *32) echo i386 ;; *64) echo x86_64 ;; *) echo Unknown-arch-1 ;; esac ;;
-       debootstrap)
-           case $personality in *32) echo i386 ;; *64) echo amd64 ;; *) echo Unknown-arch-2 ;; esac ;;
-       *)
-           echo Unknown-arch-3 ;;
+       squeeze|wheezy) 
+           echo http://ftp2.fr.debian.org/debian/ ;;
+       oneiric|precise|quantal|raring|saucy) 
+           echo http://mir1.ovh.net/ubuntu/ubuntu/ ;;
+       *) echo unknown distro $fcdistro; exit 1;;
     esac
 }
 
-# the new test framework creates /timestamp in /vservers/<name> *before* populating it
-function almost_empty () { 
-    dir="$1"; shift ; 
-    # non existing is fine
-    [ ! -d $dir ] && return 0; 
-    # need to have at most one file
-    count=$(cd $dir; ls | wc -l); [ $count -le 1 ]; 
+function debian_install () {
+    set -e
+    set -x
+    mkdir -p $rootfs_path
+    arch=$(canonical_arch $personality $fcdistro)
+    mirror=$(debian_mirror $fcdistro)
+    # old guests have mount in /bin but this is no longer part of 
+    # the standard PATH in recent hosts
+    PATH=$PATH:/bin:/sbin debootstrap --arch $arch $fcdistro $rootfs_path $mirror
 }
 
+function debian_configure () {
+    echo "WARNING No debian config available yet"
+}
+##############################
 function setup_lxc() {
 
     set -x
@@ -575,31 +529,26 @@ function setup_lxc() {
     personality=$1; shift
 
     # create lxc container 
-    copy_configuration
-    if [ $? -ne 0 ]; then
-        echo "failed write configuration file"
-        exit 1
-    fi
-
-    install_fedora
-    if [ $? -ne 0 ]; then
-        echo "failed to install fedora"
-        exit 1
-    fi
-
-    configure_fedora
-    if [ $? -ne 0 ]; then
-        echo "failed to configure fedora for a container"
-        exit 1
-    fi
-
-    if [ "$(echo $fcdistro | cut -d"f" -f2)" -le "14" ]; then
-        configure_fedora_init
-    else
-        configure_fedora_systemd
-    fi
+    
+    pkg_method=$(package_method $fcdistro)
+    case $pkg_method in
+       yum)
+           fedora_install || { echo "failed to install fedora root image"; exit 1 ; }
+           fedora_configure || { echo "failed to configure fedora for a container"; exit 1 ; }
+           ;;
+       debootstrap)
+           debian_install || { echo "failed to install debian/ubuntu root image"; exit 1 ; }
+           debian_configure || { echo "failed to configure debian/ubuntu for a container"; exit 1 ; }
+           echo "$COMMAND: no support for debootstrap-based systems - yet"
+           exit 1
+           ;;
+       *)
+           echo "$COMMAND:: unknown package_method - exiting"
+           exit 1
+           ;;
+    esac
 
-    # Enable cgroup
+    # Enable cgroup -- xxx -- is this really useful ?
     mkdir $rootfs_path/cgroup
     
     # set up resolv.conf
@@ -607,14 +556,29 @@ function setup_lxc() {
     # and /etc/hosts for at least localhost
     [ -f $rootfs_path/etc/hosts ] || echo "127.0.0.1 localhost localhost.localdomain" > $rootfs_path/etc/hosts
     
-    # ssh access to lxc
+    # grant ssh access from host to guest
     mkdir $rootfs_path/root/.ssh
     cat /root/.ssh/id_rsa.pub >> $rootfs_path/root/.ssh/authorized_keys
     
-    # copy libvirt xml template
-    veth_pair="i$(echo $HOSTNAME | cut -d. -f1)" 
-    tmpl_name="$lxc.xml"
-    cat > $config_path/$tmpl_name<<EOF
+    config_xml=$config_path/"lxc.xml"
+    guest_ifcfg=${rootfs_path}/etc/sysconfig/network-scripts/ifcfg-$VIF_GUEST
+    if [ -n "$BUILD_MODE" ] ; then
+       write_lxc_xml_build $lxc > $config_xml
+       write_guest_ifcfg_build > $guest_ifcfg
+    else
+       write_lxc_xml_test $lxc > $config_xml
+       write_guest_ifcfg_test > $guest_ifcfg
+    fi
+    
+    # define lxc container for libvirt
+    virsh -c lxc:/// define $config_xml
+
+    return 0
+}
+
+function write_lxc_xml_test () {
+    lxc=$1; shift
+    cat <<EOF
 <domain type='lxc'>
   <name>$lxc</name>
   <memory>524288</memory>
@@ -637,28 +601,79 @@ function setup_lxc() {
       <target dir='/'/>
     </filesystem>
     <interface type="bridge">
-      <source bridge="br0"/>
-      <target dev='$veth_pair'/>
+      <source bridge="$PUBLIC_BRIDGE"/>
+      <target dev='$VIF_HOST'/>
     </interface>
     <console type='pty' />
   </devices>
   <network>
     <name>host-bridge</name>
     <forward mode="bridge"/>
-    <bridge name="br0"/>
+    <bridge name="$PUBLIC_BRIDGE"/>
   </network>
 </domain>
 EOF
-   
-    # define lxc container for libvirt
-    virsh -c lxc:// define $config_path/$tmpl_name
+}
 
-    # rpm --rebuilddb
-    chroot $rootfs_path /bin/rpm --rebuilddb
+function write_lxc_xml_build () { 
+    lxc=$1; shift
+    cat <<EOF
+<domain type='lxc'>
+  <name>$lxc</name>
+  <memory>524288</memory>
+  <os>
+    <type arch='$arch2'>exe</type>
+    <init>/sbin/init</init>
+  </os>
+  <features>
+    <acpi/>
+  </features>
+  <vcpu>1</vcpu>
+  <clock offset='utc'/>
+  <on_poweroff>destroy</on_poweroff>
+  <on_reboot>restart</on_reboot>
+  <on_crash>destroy</on_crash>
+  <devices>
+    <emulator>/usr/libexec/libvirt_lxc</emulator>
+    <filesystem type='mount'>
+      <source dir='$rootfs_path'/>
+      <target dir='/'/>
+    </filesystem>
+    <interface type="network">
+      <source network="default"/>
+    </interface>
+    <console type='pty' />
+  </devices>
+</domain>
+EOF
+}
 
-    configure_yum_in_lxc $lxc $fcdistro $pldistro
+# this one is dhcp-based
+function write_guest_ifcfg_build () {
+    cat <<EOF
+DEVICE=$VIF_GUEST
+BOOTPROTO=dhcp
+ONBOOT=yes
+NM_CONTROLLED=no
+TYPE=Ethernet
+MTU=1500
+EOF
+}
 
-    return 0
+# use fixed IP as specified by GUEST_HOSTNAME
+function write_guest_ifcfg_test () {
+    cat <<EOF
+DEVICE=$VIF_GUEST
+BOOTPROTO=static
+ONBOOT=yes
+HOSTNAME=$GUEST_HOSTNAME
+IPADDR=$IP
+NETMASK=$NETMASK
+GATEWAY=$GATEWAY
+NM_CONTROLLED=no
+TYPE=Ethernet
+MTU=1500
+EOF
 }
 
 function devel_or_vtest_tools () {
@@ -674,13 +689,7 @@ function devel_or_vtest_tools () {
 
     pkg_method=$(package_method $fcdistro)
 
-    # check for .pkgs file based on pldistro
-    if [ -n "$BUILD_MODE" ] ; then
-       pkgsname=devel.pkgs
-    else
-       pkgsname=vtest.pkgs
-    fi
-    pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $pkgsname)
+    pkgsfile=$(pl_locateDistroFile $DIRNAME $pldistro $PREINSTALLED)
 
     ### install individual packages, then groups
     # get target arch - use uname -i here (we want either x86_64 or i386)
@@ -718,13 +727,19 @@ function devel_or_vtest_tools () {
 }
 
 function post_install () {
+    lxc=$1; shift 
+    personality=$1; shift
     if [ -n "$BUILD_MODE" ] ; then
-       post_install_build "$@" 
+       post_install_build $lxc $personality
+       lxc_start $lxc
+       # manually run dhclient in guest - somehow this network won't start on its own
+       virsh -c lxc:/// lxc-enter-namespace $lxc /usr/sbin/dhclient $VIF_GUEST
     else
-       post_install_myplc "$@"
+       post_install_myplc $lxc $personality
+       lxc_start $lxc
+       wait_for_ssh $lxc
     fi
     # setup localtime from the host
-    lxc=$1; shift 
     cp /etc/localtime $rootfs_path/etc/localtime
 }
 
@@ -785,7 +800,7 @@ PROFILE
     fi
 #
 EOF
-
+       
 }
 
 function post_install_myplc  () {
@@ -819,7 +834,7 @@ PROFILE
 EOF
 }
 
-function start_lxc() {
+function lxc_start() {
 
     set -x
     set -e
@@ -827,7 +842,17 @@ function start_lxc() {
 
     lxc=$1; shift
   
-    virsh -c lxc:// start $lxc
+    virsh -c lxc:/// start $lxc
+  
+    return 0
+}
+
+function wait_for_ssh () {
+    set -x
+    set -e
+    #trap failure ERR INT
+
+    lxc=$1; shift
   
     echo $IP is up, waiting for ssh...
 
@@ -847,27 +872,30 @@ function start_lxc() {
 
     # Thierry: this is fatal, let's just exit with a failure here
     [ -z $ssh_up ] && { echo "SSHD in container $lxc is not running" ; exit 1 ; } 
-
     return 0
 }
 
+####################
+function failure () {
+    echo "$COMMAND : Bailing out"
+    exit 1
+}
+
 function usage () {
     set +x 
     echo "Usage: $COMMAND_LBUILD [options] lxc-name"
-    echo "Usage: $COMMAND_LTEST [options] lxc-name repo-url [ -- lxc-options ]"
+    echo "Usage: $COMMAND_LTEST [options] lxc-name"
     echo "Description:"
-    echo "   This command creates a fresh lxc instance, for building, or running, myplc"
+    echo "   This command creates a fresh lxc instance, for building, or running a test myplc"
     echo "Supported options"
     echo " -f fcdistro - for creating the root filesystem - defaults to $DEFAULT_FCDISTRO"
     echo " -d pldistro - defaults to $DEFAULT_PLDISTRO"
     echo " -p personality - defaults to $DEFAULT_PERSONALITY"
-    echo " -i ifname: determines ip and netmask attached to ifname, and passes it to the lxc"
-    echo "-- lxc-options"
-    echo "  --netdev : interface to be defined inside lxc"
-    echo "  --interface : IP to be defined for the lxc"
-    echo "  --hostname : Hostname to be defined for the lxc"
-    echo "With $COMMAND_LTEST you can give 'none' as the URL, in which case"
-    echo "   myplc.repo does not get created"
+    echo " -n hostname - the hostname to use in container - required with $COMMAND_LTEST"
+    echo " -r repo-url - used to populate yum.repos.d - required with $COMMAND_LTEST"
+    echo " -P pkgs_file - defines the set of extra pacakges"
+    echo "    by default we use vtest.pkgs or devel.pkgs according to $COMMAND"
+    echo " -v be verbose"
     exit 1
 }
 
@@ -877,6 +905,11 @@ function main () {
     #set -e
     #trap failure ERR INT
 
+    if [ "$(id -u)" != "0" ]; then
+          echo "This script should be run as 'root'"
+          exit 1
+    fi
+
     case "$COMMAND" in
        $COMMAND_LBUILD)
            BUILD_MODE=true ;;
@@ -886,16 +919,23 @@ function main () {
            usage ;;
     esac
 
-    VERBOSE=
-    RESISTANT=""
-    IFNAME=""
-    LXC_OPTIONS=""
-    while getopts "f:d:p:i:" opt ; do
+    echo 'build mode=' $BUILD_MODE 'test mode=' $TEST_MODE
+
+    # the set of preinstalled packages - depends on vbuild or vtest
+    if [ -n "$BUILD_MODE" ] ; then
+       PREINSTALLED=devel.pkgs
+    else
+       PREINSTALLED=vtest.pkgs
+    fi
+    while getopts "f:d:p:n:r:P:v" opt ; do
        case $opt in
            f) fcdistro=$OPTARG;;
            d) pldistro=$OPTARG;;
            p) personality=$OPTARG;;
-           i) IFNAME=$OPTARG;;
+           n) GUEST_HOSTNAME=$OPTARG;;
+           r) REPO_URL=$OPTARG;;
+           P) PREINSTALLED=$OPTARG;;
+           v) VERBOSE=true; set -x;;
            *) usage ;;
        esac
     done
@@ -905,43 +945,27 @@ function main () {
     # parse fixed arguments
     [[ -z "$@" ]] && usage
     lxc=$1 ; shift
-    if [ -n "$TEST_MODE" ] ; then
-       [[ -z "$@" ]] && usage
-       REPO_URL=$1 ; shift
-    fi
-
-    # parse vserver options
-    if [[ -n "$@" ]] ; then
-       if [ "$1" == "--" ] ; then
-           shift
-           LXC_OPTIONS="$@"
-       else
-           usage
-       fi
-    fi
-
-    eval set -- "$LXC_OPTIONS"
 
-    while true
-     do
-        case "$1" in
-             --netdev)      IFNAME=$2; shift 2;;
-             --interface)   IP=$2; shift 2;;
-             --hostname)    HOSTNAME=$2; shift 2;;
-             *)             break ;;
-        esac
-      done
-
-   
-    if [ -n "$BUILD_MODE" ] ; then
-       [ -z "$IFNAME" ] && IFNAME=$DEFAULT_IFNAME
-        [ -z "$HOSTNAME" ] && HOSTNAME=$lxc
-    fi
+    # check we've exhausted the arguments
+    [[ -n "$@" ]] && usage
 
     [ -z "$fcdistro" ] && fcdistro=$DEFAULT_FCDISTRO
     [ -z "$pldistro" ] && pldistro=$DEFAULT_PLDISTRO
     [ -z "$personality" ] && personality=$DEFAULT_PERSONALITY
     
+    if [ -n "$BUILD_MODE" ] ; then
+        [ -z "$GUEST_HOSTNAME" ] && GUEST_HOSTNAME=$lxc
+    else
+       [[ -z "$GUEST_HOSTNAME" ]] && usage
+       # use -r none to get rid of this warning
+       if [ "$REPO_URL" == "none" ] ; then
+           REPO_URL=""
+       elif [ -z "$REPO_URL" ] ; then
+           echo "WARNING -- setting up a yum repo is recommended" 
+       fi
+    fi
+
+    ##########
     release=$(echo $fcdistro | cut -df -f2)
 
     if [ "$personality" == "linux32" ]; then
@@ -954,44 +978,28 @@ function main () {
         echo "Unknown personality: $personality"
     fi
 
-    # need lxc installed before we can run lxc-ls
-    # need bridge installed
-    prepare_host    
-
     if [ -n "$BUILD_MODE" ] ; then
 
        # Bridge IP affectation
-       x=$(echo $personality | cut -dx -f2)
-       y=$(echo $fcdistro | cut -df -f2)
-       z=$(($x + $y))
-
-        IP="192.168.122.$z"
-        NETMASK="255.255.255.0"
-        GATEWAY="192.168.122.1"
-       
-        lxc_network_type=veth
-        lxc_network_link=virbr0
-       veth_pair="veth$z"
-        echo "the IP address of container $lxc is $IP "
+       byte=$(random_private_byte)
+       IP=${PRIVATE_PREFIX}$byte
+       NETMASK=$(masklen_to_netmask $PRIVATE_MASKLEN)
+       GATEWAY=$PRIVATE_GATEWAY
+       VIF_HOST="i$byte"
     else
-        [[ -z "$REPO_URL" ]] && usage
-        [[ -z "$IP" ]] && usage
+        [[ -z "GUEST_HOSTNAME" ]] && usage
        
-        NETMASK=$(ifconfig br0 | grep 'inet ' | awk '{print $4}' | sed -e 's/.*://')
-        GATEWAY=$(route -n | grep 'UG' | awk '{print $2}')
-        [[ -z "$HOSTNAME" ]] && usage
-        lxc_network_type=veth
-        lxc_network_link=br0
-        veth_pair="i$(echo $HOSTNAME | cut -d. -f1)"
+       create_bridge_if_needed
+
+       IP=$(gethostbyname $GUEST_HOSTNAME)
+       # use same NETMASK as bridge interface br0
+       MASKLEN=$(ip addr show $PUBLIC_BRIDGE | grep -v inet6 | grep inet | awk '{print $2;}' | cut -d/ -f2)
+        NETMASK=$(masklen_to_netmask $MASKLEN)
+        GATEWAY=$(ip route show | grep default | awk '{print $3}')
+        VIF_HOST="i$(echo $GUEST_HOSTNAME | cut -d. -f1)"
     fi
 
-    CIDR=$(cidr_notation $NETMASK)
-    
-
-    if [ "$(id -u)" != "0" ]; then
-          echo "This script should be run as 'root'"
-          exit 1
-    fi
+    echo "the IP address of container $lxc is $IP, host virtual interface is $VIF_HOST"
 
     path=/vservers
     [ ! -d $path ] && mkdir $path
@@ -1003,7 +1011,10 @@ function main () {
     
     # check whether the rootfs directory is created to know if the container exists
     # bacause /var/lib/lxc/$lxc is already created while putting $lxc.timestamp
-    [ -d $rootfs_path ] && { echo "container $lxc already exists - exiting" ; exit 1 ; }
+    [ -d $rootfs_path ] && \
+       { echo "container $lxc already exists in filesystem - exiting" ; exit 1 ; }
+    virsh -c lxc:/// domuuid $lxc >& /dev/null && \
+       { echo "container $lxc already exists in libvirt - exiting" ; exit 1 ; }
 
     setup_lxc $lxc $fcdistro $pldistro $personality 
 
@@ -1011,8 +1022,6 @@ function main () {
 
     post_install $lxc $personality
     
-    start_lxc $lxc
-
     echo $COMMAND Done
 }